var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { renderToString } from 'react-dom/server';
import { BODY_ATTRIBUTES_KEY } from './Body';
import { HTML_ATTRIBUTES_KEY } from './Html';
/**
 * Extract props from a list of tags a specific tag by using a key
 * and then discard this key before returning the key
 */
var extractPropsFrom = function (tags, _a) {
    var withKey = _a.withKey;
    // search the tag using the key and default to an empty object for simplicity
    var tag = tags.find(function (_a) {
        var props = _a.props;
        return props.name === withKey;
    });
    if (tag != null) {
        // discard the key used to search the tag
        var _b = tag.props, name_1 = _b.name, restOfTag = __rest(_b, ["name"]);
        // return only the desired info for the tag
        return restOfTag;
    }
};
/**
 * Transform the object from the head to a string to be used in the server
 */
var transformToString = function (headObject) {
    if (headObject === void 0) { headObject = {}; }
    return Object.entries(headObject)
        .map(function (_a) {
        var key = _a[0], value = _a[1];
        return key + "=\"" + value + "\"";
    })
        .join(' ');
};
/**
 * Render the tags for the head
 */
export function renderHeadTagsToString(headTags) {
    var bodyAttributesProps = extractPropsFrom(headTags, {
        withKey: BODY_ATTRIBUTES_KEY
    });
    var htmlAttributesProps = extractPropsFrom(headTags, {
        withKey: HTML_ATTRIBUTES_KEY
    });
    var headTagsToRender = headTags.filter(function (_a) {
        var props = _a.props;
        return props.name !== BODY_ATTRIBUTES_KEY && props.name !== HTML_ATTRIBUTES_KEY;
    });
    return {
        headString: renderToString(headTagsToRender),
        bodyAttributes: transformToString(bodyAttributesProps),
        htmlAttributes: transformToString(htmlAttributesProps)
    };
}
